<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/env_logger-0.9.0/src/fmt/writer/termcolor/extern_impl.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>extern_impl.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../../storage.js"></script><script defer src="../../../../../source-script.js"></script><script defer src="../../../../../source-files.js"></script><script defer src="../../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/static/images/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../../env_logger/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../../env_logger/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../../env_logger/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::borrow::Cow</span>;
<span class="kw">use</span> <span class="ident">std::cell::RefCell</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::io</span>::{<span class="self">self</span>, <span class="ident">Write</span>};
<span class="kw">use</span> <span class="ident">std::rc::Rc</span>;
<span class="kw">use</span> <span class="ident">std::sync::Mutex</span>;

<span class="kw">use</span> <span class="ident">log::Level</span>;
<span class="kw">use</span> <span class="ident">termcolor</span>::{<span class="self">self</span>, <span class="ident">ColorChoice</span>, <span class="ident">ColorSpec</span>, <span class="ident">WriteColor</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::fmt</span>::{<span class="ident">Formatter</span>, <span class="ident">WritableTarget</span>, <span class="ident">WriteStyle</span>};

<span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">mod</span> <span class="ident">glob</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
}

<span class="kw">impl</span> <span class="ident">Formatter</span> {
    <span class="doccomment">/// Begin a new [`Style`].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a bold, red colored style and use it to print the log level:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">/// use env_logger::fmt::Color;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut level_style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     level_style.set_color(Color::Red).set_bold(true);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}: {}&quot;,</span>
    <span class="doccomment">///         level_style.value(record.level()),</span>
    <span class="doccomment">///         record.args())</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [`Style`]: struct.Style.html</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">style</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Style</span> {
        <span class="ident">Style</span> {
            <span class="ident">buf</span>: <span class="self">self</span>.<span class="ident">buf</span>.<span class="ident">clone</span>(),
            <span class="ident">spec</span>: <span class="ident">ColorSpec::new</span>(),
        }
    }

    <span class="doccomment">/// Get the default [`Style`] for the given level.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The style can be used to print other values besides the level.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">default_level_style</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">level</span>: <span class="ident">Level</span>) -&gt; <span class="ident">Style</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">level_style</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">style</span>();
        <span class="kw">match</span> <span class="ident">level</span> {
            <span class="ident">Level::Trace</span> =&gt; <span class="ident">level_style</span>.<span class="ident">set_color</span>(<span class="ident">Color::Cyan</span>),
            <span class="ident">Level::Debug</span> =&gt; <span class="ident">level_style</span>.<span class="ident">set_color</span>(<span class="ident">Color::Blue</span>),
            <span class="ident">Level::Info</span> =&gt; <span class="ident">level_style</span>.<span class="ident">set_color</span>(<span class="ident">Color::Green</span>),
            <span class="ident">Level::Warn</span> =&gt; <span class="ident">level_style</span>.<span class="ident">set_color</span>(<span class="ident">Color::Yellow</span>),
            <span class="ident">Level::Error</span> =&gt; <span class="ident">level_style</span>.<span class="ident">set_color</span>(<span class="ident">Color::Red</span>).<span class="ident">set_bold</span>(<span class="bool-val">true</span>),
        };
        <span class="ident">level_style</span>
    }

    <span class="doccomment">/// Get a printable [`Style`] for the given level.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The style can only be used to print the level.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">default_styled_level</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">level</span>: <span class="ident">Level</span>) -&gt; <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span>, <span class="ident">Level</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">default_level_style</span>(<span class="ident">level</span>).<span class="ident">into_value</span>(<span class="ident">level</span>)
    }
}

<span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">struct</span> <span class="ident">BufferWriter</span> {
    <span class="ident">inner</span>: <span class="ident">termcolor::BufferWriter</span>,
    <span class="ident">test_target</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">WritableTarget</span><span class="op">&gt;</span>,
}

<span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt</span>) <span class="kw">struct</span> <span class="ident">Buffer</span> {
    <span class="ident">inner</span>: <span class="ident">termcolor::Buffer</span>,
    <span class="ident">has_test_target</span>: <span class="ident">bool</span>,
}

<span class="kw">impl</span> <span class="ident">BufferWriter</span> {
    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">fn</span> <span class="ident">stderr</span>(<span class="ident">is_test</span>: <span class="ident">bool</span>, <span class="ident">write_style</span>: <span class="ident">WriteStyle</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">BufferWriter</span> {
            <span class="ident">inner</span>: <span class="ident">termcolor::BufferWriter::stderr</span>(<span class="ident">write_style</span>.<span class="ident">into_color_choice</span>()),
            <span class="ident">test_target</span>: <span class="kw">if</span> <span class="ident">is_test</span> {
                <span class="prelude-val">Some</span>(<span class="ident">WritableTarget::Stderr</span>)
            } <span class="kw">else</span> {
                <span class="prelude-val">None</span>
            },
        }
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">fn</span> <span class="ident">stdout</span>(<span class="ident">is_test</span>: <span class="ident">bool</span>, <span class="ident">write_style</span>: <span class="ident">WriteStyle</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">BufferWriter</span> {
            <span class="ident">inner</span>: <span class="ident">termcolor::BufferWriter::stdout</span>(<span class="ident">write_style</span>.<span class="ident">into_color_choice</span>()),
            <span class="ident">test_target</span>: <span class="kw">if</span> <span class="ident">is_test</span> {
                <span class="prelude-val">Some</span>(<span class="ident">WritableTarget::Stdout</span>)
            } <span class="kw">else</span> {
                <span class="prelude-val">None</span>
            },
        }
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">fn</span> <span class="ident">pipe</span>(
        <span class="ident">is_test</span>: <span class="ident">bool</span>,
        <span class="ident">write_style</span>: <span class="ident">WriteStyle</span>,
        <span class="ident">pipe</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">Mutex</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">io::Write</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="lifetime">&#39;static</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    ) -&gt; <span class="self">Self</span> {
        <span class="ident">BufferWriter</span> {
            <span class="comment">// The inner Buffer is never printed from, but it is still needed to handle coloring and other formating</span>
            <span class="ident">inner</span>: <span class="ident">termcolor::BufferWriter::stderr</span>(<span class="ident">write_style</span>.<span class="ident">into_color_choice</span>()),
            <span class="ident">test_target</span>: <span class="kw">if</span> <span class="ident">is_test</span> {
                <span class="prelude-val">Some</span>(<span class="ident">WritableTarget::Pipe</span>(<span class="ident">pipe</span>))
            } <span class="kw">else</span> {
                <span class="prelude-val">None</span>
            },
        }
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">fn</span> <span class="ident">buffer</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Buffer</span> {
        <span class="ident">Buffer</span> {
            <span class="ident">inner</span>: <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">buffer</span>(),
            <span class="ident">has_test_target</span>: <span class="self">self</span>.<span class="ident">test_target</span>.<span class="ident">is_some</span>(),
        }
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt::writer</span>) <span class="kw">fn</span> <span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="ident">Buffer</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">target</span>) <span class="op">=</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">test_target</span> {
            <span class="comment">// This impl uses the `eprint` and `print` macros</span>
            <span class="comment">// instead of `termcolor`&#39;s buffer.</span>
            <span class="comment">// This is so their output can be captured by `cargo test`</span>
            <span class="kw">let</span> <span class="ident">log</span> <span class="op">=</span> <span class="ident">String::from_utf8_lossy</span>(<span class="ident">buf</span>.<span class="ident">bytes</span>());

            <span class="kw">match</span> <span class="ident">target</span> {
                <span class="ident">WritableTarget::Stderr</span> =&gt; <span class="macro">eprint!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">log</span>),
                <span class="ident">WritableTarget::Stdout</span> =&gt; <span class="macro">print!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">log</span>),
                <span class="ident">WritableTarget::Pipe</span>(<span class="ident">pipe</span>) =&gt; <span class="macro">write!</span>(<span class="ident">pipe</span>.<span class="ident">lock</span>().<span class="ident">unwrap</span>(), <span class="string">&quot;{}&quot;</span>, <span class="ident">log</span>)<span class="question-mark">?</span>,
            }

            <span class="prelude-val">Ok</span>(())
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>.<span class="ident">inner</span>)
        }
    }
}

<span class="kw">impl</span> <span class="ident">Buffer</span> {
    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt</span>) <span class="kw">fn</span> <span class="ident">clear</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">clear</span>()
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt</span>) <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">write</span>(<span class="ident">buf</span>)
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt</span>) <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">flush</span>()
    }

    <span class="kw">pub</span>(<span class="kw">in</span> <span class="ident"><span class="kw">crate</span>::fmt</span>) <span class="kw">fn</span> <span class="ident">bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">as_slice</span>()
    }

    <span class="kw">fn</span> <span class="ident">set_color</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">spec</span>: <span class="kw-2">&amp;</span><span class="ident">ColorSpec</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// Ignore styles for test captured logs because they can&#39;t be printed</span>
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">has_test_target</span> {
            <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">set_color</span>(<span class="ident">spec</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">Ok</span>(())
        }
    }

    <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// Ignore styles for test captured logs because they can&#39;t be printed</span>
        <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">has_test_target</span> {
            <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">reset</span>()
        } <span class="kw">else</span> {
            <span class="prelude-val">Ok</span>(())
        }
    }
}

<span class="kw">impl</span> <span class="ident">WriteStyle</span> {
    <span class="kw">fn</span> <span class="ident">into_color_choice</span>(<span class="self">self</span>) -&gt; <span class="ident">ColorChoice</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">WriteStyle::Always</span> =&gt; <span class="ident">ColorChoice::Always</span>,
            <span class="ident">WriteStyle::Auto</span> =&gt; <span class="ident">ColorChoice::Auto</span>,
            <span class="ident">WriteStyle::Never</span> =&gt; <span class="ident">ColorChoice::Never</span>,
        }
    }
}

<span class="doccomment">/// A set of styles to apply to the terminal output.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Call [`Formatter::style`] to get a `Style` and use the builder methods to</span>
<span class="doccomment">/// set styling properties, like [color] and [weight].</span>
<span class="doccomment">/// To print a value using the style, wrap it in a call to [`value`] when the log</span>
<span class="doccomment">/// record is formatted.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Create a bold, red colored style and use it to print the log level:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::io::Write;</span>
<span class="doccomment">/// use env_logger::fmt::Color;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// builder.format(|buf, record| {</span>
<span class="doccomment">///     let mut level_style = buf.style();</span>
<span class="doccomment">///</span>
<span class="doccomment">///     level_style.set_color(Color::Red).set_bold(true);</span>
<span class="doccomment">///</span>
<span class="doccomment">///     writeln!(buf, &quot;{}: {}&quot;,</span>
<span class="doccomment">///         level_style.value(record.level()),</span>
<span class="doccomment">///         record.args())</span>
<span class="doccomment">/// });</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Styles can be re-used to output multiple values:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::io::Write;</span>
<span class="doccomment">/// use env_logger::fmt::Color;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// builder.format(|buf, record| {</span>
<span class="doccomment">///     let mut bold = buf.style();</span>
<span class="doccomment">///</span>
<span class="doccomment">///     bold.set_bold(true);</span>
<span class="doccomment">///</span>
<span class="doccomment">///     writeln!(buf, &quot;{}: {} {}&quot;,</span>
<span class="doccomment">///         bold.value(record.level()),</span>
<span class="doccomment">///         bold.value(&quot;some bold text&quot;),</span>
<span class="doccomment">///         record.args())</span>
<span class="doccomment">/// });</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Formatter::style`]: struct.Formatter.html#method.style</span>
<span class="doccomment">/// [color]: #method.set_color</span>
<span class="doccomment">/// [weight]: #method.set_bold</span>
<span class="doccomment">/// [`value`]: #method.value</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Style</span> {
    <span class="ident">buf</span>: <span class="ident">Rc</span><span class="op">&lt;</span><span class="ident">RefCell</span><span class="op">&lt;</span><span class="ident">Buffer</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">spec</span>: <span class="ident">ColorSpec</span>,
}

<span class="doccomment">/// A value that can be printed using the given styles.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// It is the result of calling [`Style::value`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Style::value`]: struct.Style.html#method.value</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> {
    <span class="ident">style</span>: <span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">Style</span><span class="op">&gt;</span>,
    <span class="ident">value</span>: <span class="ident">T</span>,
}

<span class="kw">impl</span> <span class="ident">Style</span> {
    <span class="doccomment">/// Set the text color.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a style with red text:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">/// use env_logger::fmt::Color;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     style.set_color(Color::Red);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}&quot;, style.value(record.args()))</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_color</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">color</span>: <span class="ident">Color</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">Style</span> {
        <span class="self">self</span>.<span class="ident">spec</span>.<span class="ident">set_fg</span>(<span class="prelude-val">Some</span>(<span class="ident">color</span>.<span class="ident">into_termcolor</span>()));
        <span class="self">self</span>
    }

    <span class="doccomment">/// Set the text weight.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If `yes` is true then text will be written in bold.</span>
    <span class="doccomment">/// If `yes` is false then text will be written in the default weight.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a style with bold text:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     style.set_bold(true);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}&quot;, style.value(record.args()))</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_bold</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">Style</span> {
        <span class="self">self</span>.<span class="ident">spec</span>.<span class="ident">set_bold</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Set the text intensity.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If `yes` is true then text will be written in a brighter color.</span>
    <span class="doccomment">/// If `yes` is false then text will be written in the default color.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a style with intense text:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     style.set_intense(true);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}&quot;, style.value(record.args()))</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_intense</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">Style</span> {
        <span class="self">self</span>.<span class="ident">spec</span>.<span class="ident">set_intense</span>(<span class="ident">yes</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Set the background color.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a style with a yellow background:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">/// use env_logger::fmt::Color;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     style.set_bg(Color::Yellow);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}&quot;, style.value(record.args()))</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_bg</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">color</span>: <span class="ident">Color</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">Style</span> {
        <span class="self">self</span>.<span class="ident">spec</span>.<span class="ident">set_bg</span>(<span class="prelude-val">Some</span>(<span class="ident">color</span>.<span class="ident">into_termcolor</span>()));
        <span class="self">self</span>
    }

    <span class="doccomment">/// Wrap a value in the style.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The same `Style` can be used to print multiple different values.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a bold, red colored style and use it to print the log level:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::io::Write;</span>
    <span class="doccomment">/// use env_logger::fmt::Color;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let mut builder = env_logger::Builder::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// builder.format(|buf, record| {</span>
    <span class="doccomment">///     let mut style = buf.style();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     style.set_color(Color::Red).set_bold(true);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     writeln!(buf, &quot;{}: {}&quot;,</span>
    <span class="doccomment">///         style.value(record.level()),</span>
    <span class="doccomment">///         record.args())</span>
    <span class="doccomment">/// });</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">value</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">value</span>: <span class="ident">T</span>) -&gt; <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="ident">StyledValue</span> {
            <span class="ident">style</span>: <span class="ident">Cow::Borrowed</span>(<span class="self">self</span>),
            <span class="ident">value</span>,
        }
    }

    <span class="doccomment">/// Wrap a value in the style by taking ownership of it.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">into_value</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">value</span>: <span class="ident">T</span>) -&gt; <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span>, <span class="ident">T</span><span class="op">&gt;</span> {
        <span class="ident">StyledValue</span> {
            <span class="ident">style</span>: <span class="ident">Cow::Owned</span>(<span class="self">self</span>),
            <span class="ident">value</span>,
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">write_fmt</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="ident">F</span>) -&gt; <span class="ident">fmt::Result</span>
    <span class="kw">where</span>
        <span class="ident">F</span>: <span class="ident">FnOnce</span>() -&gt; <span class="ident">fmt::Result</span>,
    {
        <span class="self">self</span>.<span class="ident">style</span>
            .<span class="ident">buf</span>
            .<span class="ident">borrow_mut</span>()
            .<span class="ident">set_color</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">style</span>.<span class="ident">spec</span>)
            .<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">fmt::Error</span>)<span class="question-mark">?</span>;

        <span class="comment">// Always try to reset the terminal style, even if writing failed</span>
        <span class="kw">let</span> <span class="ident">write</span> <span class="op">=</span> <span class="ident">f</span>();
        <span class="kw">let</span> <span class="ident">reset</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">style</span>.<span class="ident">buf</span>.<span class="ident">borrow_mut</span>().<span class="ident">reset</span>().<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">fmt::Error</span>);

        <span class="ident">write</span>.<span class="ident">and</span>(<span class="ident">reset</span>)
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Style</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Style&quot;</span>).<span class="ident">field</span>(<span class="string">&quot;spec&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">spec</span>).<span class="ident">finish</span>()
    }
}

<span class="macro">macro_rules!</span> <span class="ident">impl_styled_value_fmt</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt_trait</span>:<span class="ident">path</span>),<span class="kw-2">*</span>) =&gt; {
        $(
            <span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt_trait</span><span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt_trait</span> <span class="kw">for</span> <span class="ident">StyledValue</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> {
                <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>)-&gt;<span class="ident">fmt::Result</span> {
                    <span class="self">self</span>.<span class="ident">write_fmt</span>(<span class="op">|</span><span class="op">|</span> <span class="ident">T::fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">value</span>, <span class="ident">f</span>))
                }
            }
        )<span class="op">*</span>
    };
}

<span class="macro">impl_styled_value_fmt!</span>(
    <span class="ident">fmt::Debug</span>,
    <span class="ident">fmt::Display</span>,
    <span class="ident">fmt::Pointer</span>,
    <span class="ident">fmt::Octal</span>,
    <span class="ident">fmt::Binary</span>,
    <span class="ident">fmt::UpperHex</span>,
    <span class="ident">fmt::LowerHex</span>,
    <span class="ident">fmt::UpperExp</span>,
    <span class="ident">fmt::LowerExp</span>
);

<span class="comment">// The `Color` type is copied from https://github.com/BurntSushi/ripgrep/tree/master/termcolor</span>

<span class="doccomment">/// The set of available colors for the terminal foreground/background.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The `Ansi256` and `Rgb` colors will only output the correct codes when</span>
<span class="doccomment">/// paired with the `Ansi` `WriteColor` implementation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The `Ansi256` and `Rgb` color types are not supported when writing colors</span>
<span class="doccomment">/// on Windows using the console. If they are used on Windows, then they are</span>
<span class="doccomment">/// silently ignored and no colors will be emitted.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This set may expand over time.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type has a `FromStr` impl that can parse colors from their human</span>
<span class="doccomment">/// readable form. The format is as follows:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// 1. Any of the explicitly listed colors in English. They are matched</span>
<span class="doccomment">///    case insensitively.</span>
<span class="doccomment">/// 2. A single 8-bit integer, in either decimal or hexadecimal format.</span>
<span class="doccomment">/// 3. A triple of 8-bit integers separated by a comma, where each integer is</span>
<span class="doccomment">///    in decimal or hexadecimal format.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Hexadecimal numbers are written with a `0x` prefix.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Color</span> {
    <span class="ident">Black</span>,
    <span class="ident">Blue</span>,
    <span class="ident">Green</span>,
    <span class="ident">Red</span>,
    <span class="ident">Cyan</span>,
    <span class="ident">Magenta</span>,
    <span class="ident">Yellow</span>,
    <span class="ident">White</span>,
    <span class="ident">Ansi256</span>(<span class="ident">u8</span>),
    <span class="ident">Rgb</span>(<span class="ident">u8</span>, <span class="ident">u8</span>, <span class="ident">u8</span>),
}

<span class="kw">impl</span> <span class="ident">Color</span> {
    <span class="kw">fn</span> <span class="ident">into_termcolor</span>(<span class="self">self</span>) -&gt; <span class="ident">termcolor::Color</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Color::Black</span> =&gt; <span class="ident">termcolor::Color::Black</span>,
            <span class="ident">Color::Blue</span> =&gt; <span class="ident">termcolor::Color::Blue</span>,
            <span class="ident">Color::Green</span> =&gt; <span class="ident">termcolor::Color::Green</span>,
            <span class="ident">Color::Red</span> =&gt; <span class="ident">termcolor::Color::Red</span>,
            <span class="ident">Color::Cyan</span> =&gt; <span class="ident">termcolor::Color::Cyan</span>,
            <span class="ident">Color::Magenta</span> =&gt; <span class="ident">termcolor::Color::Magenta</span>,
            <span class="ident">Color::Yellow</span> =&gt; <span class="ident">termcolor::Color::Yellow</span>,
            <span class="ident">Color::White</span> =&gt; <span class="ident">termcolor::Color::White</span>,
            <span class="ident">Color::Ansi256</span>(<span class="ident">value</span>) =&gt; <span class="ident">termcolor::Color::Ansi256</span>(<span class="ident">value</span>),
            <span class="ident">Color::Rgb</span>(<span class="ident">r</span>, <span class="ident">g</span>, <span class="ident">b</span>) =&gt; <span class="ident">termcolor::Color::Rgb</span>(<span class="ident">r</span>, <span class="ident">g</span>, <span class="ident">b</span>),
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../../" data-current-crate="env_logger" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>